	`define WR_TRANS_STOP 	 2'b00
	`define WR_TRANS_START 	 2'b10
	`define RD_TRANS_STOP 	 2'b01
	`define RD_TRANS_START 	 2'b11	
	
	
	module cmd_interpre (
					ifclk,
					rstn,
					rdn,
					wrn,
					cmdn,
					rgdtn,
					fd,
					sel_wr,
					sel_rd,
					cmd_access	
					);
					
					

	
					
	input			ifclk;
	input			rstn;
	input			rdn;
	input			wrn;
	input			cmdn;
	input			rgdtn;
	output			cmd_access;
	inout	[15:0]	fd;
	
	output			sel_wr;
	output			sel_rd;
	
	
	reg				wait_out;
	reg		[7:0]	cmd_reg;
	reg				sel_wr;
	reg				sel_rd;
	
	
	assign cmd_access = !cmdn & !wrn & !rgdtn;
	
	
	always @(posedge ifclk or negedge rstn)
		begin
			if (!rstn)
				begin
					cmd_reg	<= 8'hzz;
				end
			else if (cmd_access) 
				begin
					cmd_reg <= fd[7:0];
				end
			else 
				begin
					cmd_reg <= cmd_reg;
				end
		end 
	
	// WR command 
		
	always @(posedge ifclk or negedge rstn)
		begin
			if (!rstn)
				begin
					sel_wr <= 1'b0;
				end
			else if (cmd_reg[1:0] == `WR_TRANS_STOP)
				begin
					sel_wr <= 1'b0;
				end
			else if (cmd_reg[1:0] == `WR_TRANS_START)
				begin
					sel_wr <= 1'b1;
				end
			else
				begin
					sel_wr <= sel_wr;
				end
		end
		
		// RD command 
		
	always @(posedge ifclk or negedge rstn)
		begin
			if (!rstn)
				begin
					sel_rd <= 1'b0;
				end
			else if (cmd_reg[1:0] == `RD_TRANS_STOP)
				begin
					sel_rd <= 1'b0;
				end
			else if (cmd_reg[1:0] == `RD_TRANS_START)
				begin
					sel_rd <= 1'b1;
				end
			else
				begin
					sel_rd <= sel_rd;
				end
		end
	
endmodule	
	
		
			
			
	