//-------------------------------------
//
//  1 word data transmission
//
//  VerilogHDL sample for SX-Card3
//
//  Prime Systems,Inc.  2009.10.6
//
//------------------------------------- 

module word_comm (
					ifclk,
					rstn,
					rdn,
					wrn,
					cmdn,
					rgdtn,
					waitn,
					fd,
					led
					
					);
					
	input			ifclk;
	input			rstn;
	input			rdn;
	input			wrn;
	input			cmdn;
	input			rgdtn;
	output			waitn;
	output	[7:0]	led;
	inout	[15:0]	fd;
	
	
	wire	[15:0]	out_fd;
	wire			sel_wr;
	wire			sel_rd;
	wire	[15:0]	incoming_dt;
	wire			cmd_access;
	wire			w_wait;
	wire			r_wait;
	wire 			rd_gate;
	

	
	
assign	fd	=	rd_gate ? out_fd	:	16'hzzzz ;

	
cmd_interpre	u1 (
					.ifclk(ifclk),
					.rstn(rstn),
					.cmdn(cmdn),
					.rdn(rdn),
					.wrn(wrn),
					.rgdtn(rgdtn),
					.fd(fd),
					.sel_wr(sel_wr),
					.sel_rd(sel_rd),
					.cmd_access(cmd_access)
					);
					
					
wr_process		u2 (
					.ifclk(ifclk),
					.rstn(rstn),
					.ena(sel_wr),
					.cmd_access(cmd_access),
					.cmdn(cmdn),
					.rdn(rdn),
					.wrn(wrn),
					.rgdtn(rgdtn),
					.fd(fd),
					.wr_wait(w_wait),
					.led(led),
					.test()
					);
					
rd_process		u3 (.ifclk(ifclk),
					.rstn(rstn),
					.ena(sel_rd),
					.cmd_access(cmd_access),
					.cmdn(cmdn),
					.rdn(rdn),
					.wrn(wrn),
					.rgdtn(rgdtn),
					.fd(out_fd),
					.rd_wait(r_wait),
					.gate(rd_gate)
					);
					
					
	assign waitn = (r_wait | w_wait);
	

	
	

endmodule
